
# @allure.step('Send get request')
import json

import allure
import requests

@allure.step('Send get request')
def send_get_request(url_param, headers_param, code=200):
    # with allure.step('send get request'):
    responce = requests.get(url_param, headers=headers_param)
    with allure.step('Check responce is correct'):
        assert responce.status_code == code, f"Responce status code is wrong. Awaited {code}," \
                                             f" get {responce.status_code}"
        allure.attach(str(responce.json()), name='responce', attachment_type=allure.attachment_type.JSON)
    return responce

@allure.step('Send post request')
def send_post_request(url_param, headers_param, body_param, code=200):
    responce = requests.post(url_param, headers=headers_param, data=json.dumps(body_param))
    with allure.step('Check responce is correct'):
        assert responce.status_code == code, f"Responce status code is wrong. Awaited {code}," \
                                             f" get {responce.status_code}. Response is {responce.json()}"
        allure.attach(str(responce.json()), name='responce', attachment_type=allure.attachment_type.JSON)
    return responce

@allure.step('Send post request')
def send_put_request(url_param, headers_param, code=200):
    responce = requests.put(url_param, headers=headers_param)
    with allure.step('Check responce is correct'):
        assert responce.status_code == code, f"Responce status code is wrong. Awaited {code}," \
                                             f" get {responce.status_code}. Response is {responce.json()}"
        allure.attach(str(responce.json()), name='responce', attachment_type=allure.attachment_type.JSON)
    return responce

@allure.step('Send post request')
def send_put_request(url_param, headers_param, body_param, code=200):
    responce = requests.delete(url_param, headers=headers_param, data=json.dumps(body_param))
    with allure.step('Check responce is correct'):
        assert responce.status_code == code, f"Responce status code is wrong. Awaited {code}," \
                                             f" get {responce.status_code}. Response is {responce.json()}"
        allure.attach(str(responce.json()), name='responce', attachment_type=allure.attachment_type.JSON)
    return responce